Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, lNetComponents, lNet;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    ApplicationProperties1: TApplicationProperties;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LUDPComponent1: TLUDPComponent;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    Timer2: TTimer;
    Procedure ApplicationProperties1Idle(Sender: TObject; Var Done: Boolean);
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure LUDPComponent1Error(Const msg: String; aSocket: TLSocket);
    Procedure LUDPComponent1Receive(aSocket: TLSocket);
    Procedure MenuItem1Click(Sender: TObject);
    Procedure MenuItem2Click(Sender: TObject);
    Procedure Timer2Timer(Sender: TObject);
  private
    fClients: Array Of TLUDPComponent;
    Procedure ClearClients;
    Procedure LUDPComponentClientReceive(aSocket: TLSocket);
  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }
Uses
  uip;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  (*
   * Historie: 0.01 = Initialversion
   *)
  caption := 'Network finder ver. 0.01';
  Memo1.Clear;
  Memo2.Clear;
  Memo3.Clear;
  edit1.text := '9876';
  edit3.text := '9876';
  edit2.text := 'Hello its me the server';
  edit4.text := 'Hello its me the client';
  fClients := Nil;
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Begin
  ClearClients;
  If LUDPComponent1.Connected Then Begin
    LUDPComponent1.Disconnect(true);
  End;
End;


Procedure TForm1.Button1Click(Sender: TObject);
Var
  N: TNetworkAdapterList;
  i: Integer;
Begin
  n := GetLocalIPs();
  Memo1.Clear;
  For i := 0 To high(n) Do Begin
    Memo1.Lines.Add(n[i].AdapterName + ': ' + n[i].IpAddress);
  End;
End;

Procedure TForm1.ApplicationProperties1Idle(Sender: TObject; Var Done: Boolean);
Var
  i: Integer;
Begin
  If assigned(fClients) Then Begin
    For i := 0 To high(fClients) Do Begin
      fClients[i].CallAction;
    End;
  End
  Else Begin
    sleep(1);
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  Memo2.Clear;
  If Button2.Caption = 'Stop server' Then Begin
    LUDPComponent1.Disconnect(true);
    Button2.caption := 'Start server';
    Memo2.lines.add('Server stopped.');
  End
  Else Begin
    LUDPComponent1.ReuseAddress := true;
    If LUDPComponent1.Listen(strtoint(edit1.text)) Then Begin
      Button2.Caption := 'Stop server';
      Memo2.Lines.Add('Start listen on:' + Edit1.Text);
    End
    Else Begin
      ShowMessage('Error, could not start server.');
    End;
  End;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Var
  N: TNetworkAdapterList;
  i: Integer;
Begin
  memo3.clear;
  ClearClients;
  n := GetLocalIPs();
  Memo3.Lines.Add('Started poll on ' + inttostr(length(n)) + ' adapters.');
  SetLength(fClients, length(n));
  For i := 0 To high(n) Do Begin
    fClients[i] := TLUDPComponent.Create(self);
    fClients[i].Name := 'UdpClient' + inttostr(i + 1);
    fClients[i].ReuseAddress := true;
    fClients[i].OnReceive := @LUDPComponentClientReceive;
    If fClients[i].Connect(n[i].IpAddress, StrToInt(Edit3.text)) Then Begin
      Timer2.Enabled := true;
      //fClients[i].CallAction;
      //fClients[i].SendMessage('Ping', LADDR_BR);
      //fClients[i].CallAction;
    End
    Else Begin
      memo3.lines.add('Error could not start UDP-Connection on adapter: ' + N[i].AdapterName);
    End;
  End;
End;

Procedure TForm1.Button4Click(Sender: TObject);
Begin
  close;
End;

Procedure TForm1.Button5Click(Sender: TObject);
Begin
  memo3.clear;
  ClearClients;
  Memo3.Lines.Add('Started poll via localhost');
  SetLength(fClients, 1);
  fClients[0] := TLUDPComponent.Create(self);
  fClients[0].Name := 'UdpClient' + inttostr(0 + 1);
  fClients[0].OnReceive := @LUDPComponentClientReceive;
  If fClients[0].Connect('127.0.0.1', StrToInt(Edit3.text)) Then Begin
    Timer2.Enabled := true;
    //fClients[0].CallAction;
    //fClients[0].SendMessage('Ping', LADDR_BR);
    //fClients[0].CallAction;
  End
  Else Begin
    memo3.lines.add('Error could not start UDP-Connection on 127.0.0.1');
  End;
End;

Procedure TForm1.LUDPComponent1Error(Const msg: String; aSocket: TLSocket);
Begin
  memo2.Lines.Add('Server error: ' + msg);
  memo2.SelStart := length(Memo2.Text) + 1;
End;

Procedure TForm1.LUDPComponent1Receive(aSocket: TLSocket);
Var
  Buf: Array[0..1023] Of Byte;
  cnt, i: Integer;
  s: String;
Begin
  If Not assigned(aSocket) Then exit;
  cnt := aSocket.Get(buf, 1024); // Irgend etwas lesen damit aSocket die anderen Felder initialisiert;
  setlength(s, cnt);
  For i := 0 To cnt - 1 Do Begin
    s[i + 1] := chr(buf[i]);
  End;
  memo2.Lines.add('Got "' + s + '" on:' + aSocket.LocalAddress + ' from ' + aSocket.PeerAddress);
  s := Edit2.Text;
  For i := 0 To length(s) - 1 Do Begin
    buf[i] := ord(s[i + 1]);
  End;
  // Und ne kleine Nachricht zurück
  aSocket.Send(buf, length(s));
End;

Procedure TForm1.MenuItem1Click(Sender: TObject);
Begin
  memo2.clear;
End;

Procedure TForm1.MenuItem2Click(Sender: TObject);
Begin
  memo3.clear;
End;

Procedure TForm1.Timer2Timer(Sender: TObject);
Var
  i: Integer;
Begin
  Timer2.Enabled := false;
  memo3.Lines.add('Send pings.');
  For i := 0 To high(fClients) Do Begin
    fClients[i].SendMessage(edit4.text, LADDR_BR);
  End;
End;

Procedure TForm1.ClearClients;
Var
  i: Integer;
Begin
  For i := 0 To high(fClients) Do Begin
    fClients[i].Disconnect(true);
    fClients[i].Free;
  End;
  setlength(fClients, 0);
End;

Procedure TForm1.LUDPComponentClientReceive(aSocket: TLSocket);
Var
  Buf: Array[0..1023] Of Byte;
  cnt, i: Integer;
  s: String;
Begin
  If Not assigned(aSocket) Then exit;
  cnt := aSocket.Get(buf, 1024); // Lesen der Antwort des Servers ;-)
  setlength(s, cnt);
  For i := 0 To cnt - 1 Do Begin
    s[i + 1] := chr(buf[i]);
  End;
  memo3.Lines.add('Got "' + s + '" on:' + aSocket.LocalAddress + ' from ' + aSocket.PeerAddress);
End;

End.

